<template>
  <div class="user-info-head" @click="editCropper()">
    <img class="img-circle img-lg" :src="options.img" title="点击上传头像" />
    <el-dialog v-model="open" append-to-body :title="title" width="800px" @close="closeDialog" @opened="modalOpened">
      <el-row>
        <el-col :md="12" :style="{ height: '350px' }" :xs="24">
          <vue-cropper
            v-if="visible"
            ref="cropper"
            :auto-crop="options.autoCrop"
            :auto-crop-height="options.autoCropHeight"
            :auto-crop-width="options.autoCropWidth"
            :fixed-box="options.fixedBox"
            :img="options.img"
            :info="true"
            :output-type="options.outputType"
            @real-time="realTime"
          />
        </el-col>
        <el-col :md="12" :style="{ height: '350px' }" :xs="24">
          <div class="avatar-upload-preview">
            <img :src="options.previews.url" :style="options.previews.img" />
          </div>
        </el-col>
      </el-row>
      <br />
      <el-row>
        <el-col :lg="2" :md="2">
          <el-upload action="#" :before-upload="beforeUpload" :http-request="requestUpload" :show-file-list="false">
            <el-button>
              选择
              <el-icon class="el-icon--right"><upload /></el-icon>
            </el-button>
          </el-upload>
        </el-col>
        <el-col :lg="{ span: 1, offset: 2 }" :md="2">
          <el-button icon="Plus" @click="changeScale(1)" />
        </el-col>
        <el-col :lg="{ span: 1, offset: 1 }" :md="2">
          <el-button icon="Minus" @click="changeScale(-1)" />
        </el-col>
        <el-col :lg="{ span: 1, offset: 1 }" :md="2">
          <el-button icon="RefreshLeft" @click="rotateLeft()" />
        </el-col>
        <el-col :lg="{ span: 1, offset: 1 }" :md="2">
          <el-button icon="RefreshRight" @click="rotateRight()" />
        </el-col>
        <el-col :lg="{ span: 2, offset: 6 }" :md="2">
          <el-button type="primary" @click="uploadImg()">提 交</el-button>
        </el-col>
      </el-row>
      <br />
    </el-dialog>
  </div>
</template>

<script setup lang="ts">
import { VueCropper } from 'vue-cropper'
import 'vue-cropper/dist/index.css'
import { uploadAvatar } from '/@/api/userManagement'
import { useUserStore } from '/@/store/modules/user'

defineOptions({
  name: 'UserAvatar',
})

const userStore = useUserStore()
const { proxy } = getCurrentInstance() as any

const open = ref<any>(false)
const visible = ref<any>(false)
const title = ref<any>('修改头像')

//图片裁剪数据
const options = reactive<any>({
  img: userStore.avatar, // 裁剪图片的地址
  autoCrop: true, // 是否默认生成截图框
  autoCropWidth: 200, // 默认生成截图框宽度
  autoCropHeight: 200, // 默认生成截图框高度
  fixedBox: true, // 固定截图框大小 不允许改变
  outputType: 'png', // 默认生成截图为PNG格式
  filename: 'avatar', // 文件名称
  previews: {}, //预览数据
})

/** 编辑头像 */
function editCropper() {
  open.value = true
}

/** 打开弹出层结束时的回调 */
function modalOpened() {
  visible.value = true
}

/** 覆盖默认上传行为 */
function requestUpload() {
  console.log('覆盖默认上传行为')
}

/** 向左旋转 */
function rotateLeft() {
  proxy.$refs.cropper.rotateLeft()
}

/** 向右旋转 */
function rotateRight() {
  proxy.$refs.cropper.rotateRight()
}

/** 图片缩放 */
function changeScale(num: any) {
  num = num || 1
  proxy.$refs.cropper.changeScale(num)
}

/** 上传预处理 */
function beforeUpload(file: any) {
  if (file.type.includes('image/')) {
    const reader = new FileReader()
    reader.readAsDataURL(file)
    reader.addEventListener('load', () => {
      options.img = reader.result
      options.filename = file.name
    })
  } else {
    proxy.$modal.msgError('文件格式错误，请上传图片类型,如：JPG，PNG后缀的文件。')
  }
}

/** 上传图片 */
function uploadImg() {
  proxy.$refs.cropper.getCropBlob((data: any) => {
    let formData = new FormData()
    formData.append('avatarfile', data, options.filename)
    uploadAvatar(formData).then((response: any) => {
      open.value = false
      options.img = import.meta.env.VITE_APP_BASE_URL + response.imgUrl
      userStore.avatar = options.img
      $baseMessage('修改成功', 'success', 'hey')
      // proxy.$modal.msgSuccess('修改成功')
      visible.value = false
    })
  })
}

/** 实时预览 */
function realTime(data: any) {
  options.previews = data
}

/** 关闭窗口 */
function closeDialog() {
  options.img = userStore.avatar
  options.visible = false
}
</script>

<style lang="scss" scoped>
.user-info-head {
  position: relative;
  display: inline-block;
  height: 120px;
}

.user-info-head:hover:after {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  font-size: 24px;
  font-style: normal;
  line-height: 110px;
  color: #eee;
  cursor: pointer;
  content: '+';
  background: rgba(0, 0, 0, 0.5);
  border-radius: 50%;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

/* image */
.img-circle {
  border-radius: 50%;
}

.img-lg {
  width: 120px;
  height: 120px;
}

.avatar-upload-preview {
  position: absolute;
  top: 50%;
  width: 200px;
  height: 200px;
  overflow: hidden;
  border-radius: 50%;
  box-shadow: 0 0 4px #ccc;
  transform: translate(50%, -50%);
}
</style>
